use strict;
print "Content-Type: text/html\n\n";


#obtain values from web form
use CGI;
my $query = new CGI;
my $recipientVal = $query->param('Recipient');
my $fnameVal = $query->param('First Name');
my $lnameVal = $query->param('Last Name');
my $emailVal = $query->param('Email');
my $sbjVal = $query->param('Subject');
my $msgVal = $query->param('Message');


#Validation and Error Feedback
my $anyError = "false";
my $fnameErr = "false";
my $emailErr = "false";
my $msgErr = "false";

if ($fnameVal eq "")
    {
        $fnameErr = "true";
        $anyError = "true";
    }
if ($emailVal eq "")
    {
        $emailErr = "true";
        $anyError = "true";
    }
if ($msgVal eq "")
    {
        $msgErr = "true";
        $anyError = "true";
    }

if ($anyError eq "true")
    {
        print "<html>";
        print "<head>";
        print "</head>";
        print "<body>";
        print "<h3>One or more fields have errors!</h3>";
        if ($fnameErr eq "true")
            {
                print "<span>The first name field cannot be empty!</span><br />";
            }
        if ($emailErr eq "true")
            {
                print "<span>The email field cannot be empty!</span><br />";
            }
        if ($msgErr eq "true")
            {
                print "<span>The message field cannot be empty!</span><br />";
            }
        print "</body>";
        print "</html>";
    }


my @time = localtime();
my @week = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
my @mYear = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

my $serverDateStr;

my $year = 1900 + $time[5];
my $hr = $time[2];
my $mn = $time[1];
my $sc = $time[0];
if (length($hr) == 1)
    {
        $hr = "0" . $hr;
    } 
if (length($mn) == 1)
    {
        $mn = "0" . $mn;
    } 
if (length($sc) == 1)
    {
        $sc = "0" . $sc;
    } 
$serverDateStr = $week[$time[6]] . ", " . $time[3] . " " . $mYear[$time[4]] . " " . $year . " " . $hr . ":" . $mn . ":" . $sc;

sub textWrap
    {
        $msgVal  =~ s/^\ +//; #remove leading space characters
        my @arr = split (/\r\n|\n/, $msgVal); #split at new lines
        my $str = ""; #final string
        foreach (@arr)
           {#form the final string inserting \n
                if (length($_) <= 78)
                    {
                        $str = $str. "$_\n";
                    }
                else
                   {#get 12 words sequences ending them with \n
                       while ($_ =~ /(\S+( \S+){1,11})/g)
                           {
                                $str = $str . $1 . "\n";
                           }
                   }
            }
        return $str;
    }


my $wrappedText = textWrap();
my $emailMessage = "From: <$emailVal>\nTo: <$recipientVal>\nSubject: $sbjVal\n$serverDateStr -0000\n\nFirst Name: $fnameVal\nSecond Name: $lnameVal\nMessage: \n\n$wrappedText";

#the following should send the mail if validation was OK
if ($anyError eq "false")
    {
        open(SENDMAIL, "|/usr/lib/sendmail -oi -t")
                                or die "Can't fork for sendmail: $!\n";
        print SENDMAIL $emailMessage;
        close(SENDMAIL)     or warn "sendmail didn't close properly";

        print "<html>";
        print "<head>";
        print "</head>";
        print "<body>";
        print "<h3>Thank You.</h3>";
        print "<h4>Your Message has been sent.</h4>";
        print "</body>";
        print "</html>";
    }
